/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */

package de.bsvrz.ste.tmc.junit.prueffall1;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.ste.tmc.junit.RDSTMCPrueffall;
import de.bsvrz.ste.tmc.junit.tools.WarteAufAktualisierteDaten;
import de.bsvrz.ste.tmc.meldungserstellung.VerwaltungMeldungen;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * @author Sans
 *
 */
public class Prueffall1_4_700s extends RDSTMCPrueffall {
	/**
	 * Debug-Logger für Logging-Ausgaben.
	 */
	private final static Debug _debug = Debug.getLogger();

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testPrueffall_1_4_700s() throws Exception {
		assertTestGeneratorLaeuft();

		SystemObject meldung5 = getDataModel().getObject(VerwaltungMeldungen.PID_PREFIX + "5");
		assertNotNull("Objekt " + VerwaltungMeldungen.PID_PREFIX + "5" + " existiert", meldung5);

		WarteAufAktualisierteDaten waad = new WarteAufAktualisierteDaten(getConnection(), getMeldungsMenge(),
				new SystemObject[] { meldung5 }, getDataDescription(), 80000 + TOL_PLUS);

		ResultData rd5 = waad.getAktualisierteDaten().get(meldung5.getPid());

		assertTrue("1 Meldungen " + meldung5.getPid() + " wurde aktualisiert",
				waad.getAktualisierteDaten().size() == 1 && rd5 != null && rd5.getObject().equals(meldung5));

		assertPruefZeitKorrekt(700000, rd5.getDataTime());

		assertMeldungsDatenKorrekt(rd5, InformationsTyp.ALERTC, MeldungsArt.AKTUALISIERUNG,
				GeografischeBedeutung.NATIONAL, ZeitlicheDringlichkeit.NORMAL, ZeitlicheDauer.UNBEKANNT, -2, 129, 11906,
				null, null);

		getConnection().sleep(1000);
	}

}
